#! /bin/sh

libtoolize -c --force && aclocal && automake -a -c --force-missing && autoconf

# Gather internal symbols...
rm -f include/vstr-internal-alias-symbols.h
touch include/vstr-internal-alias-symbols.h
rm -f include/vstr-internal-cpp-symbols.h
touch include/vstr-internal-cpp-symbols.h

rm -f include/vstr-internal-alias-inline-symbols.h
touch include/vstr-internal-alias-inline-symbols.h
rm -f include/vstr-internal-cpp-inline-symbols.h
touch include/vstr-internal-cpp-inline-symbols.h



# Do the inline helpers by hand...
perl -pe 'BEGIN { print "/* DO NOT EDIT THIS FILE */\n"; } \
          s/^(.*)\((.*)\)\n$/#ifdef $2\nVSTR__SYM($1)\n#endif\n\n/; \
          s/^([^#].*[^)])\n$/VSTR__SYM($1)\n/;' \
  include/vstr-internal.export_symbols > include/vstr-internal-alias-symbols.h
perl -pe 'BEGIN { print "/* DO NOT EDIT THIS FILE */\n"; } \
        s/^(.*)\((.*)\)\n$/#ifdef $2\n#define vstr_nx_$1 vstr_$1\n#endif\n\n/; \
        s/^([^#].*[^)])\n$/#define vstr_nx_$1 vstr_$1\n/;' \
  include/vstr-internal.export_symbols > include/vstr-internal-cpp-symbols.h

perl -pe 'BEGIN { print "/* DO NOT EDIT THIS FILE */\n"; } \
          s/^(.*)\((.*)\)\n$/#ifdef $2\nVSTR__SYM($1)\n#endif\n\n/; \
          s/^([^#].*[^)])\n$/VSTR__SYM($1)\n/;' \
  include/vstr-internal.inline_export_symbols > include/vstr-internal-alias-inline-symbols.h
perl -pe 'BEGIN { print "/* DO NOT EDIT THIS FILE */\n"; } 
        s/^(.*)\((.*)\)\n$/#ifdef $2\n#define vstr_nx_$1 vstr_$1\n#endif\n\n/; \
        s/^([^#].*[^)])\n$/#define vstr_nx_$1 vstr_$1\n/;' \
  include/vstr-internal.inline_export_symbols > include/vstr-internal-cpp-inline-symbols.h

# produce a local and external copy of vstr-extern.h ...

perl -pe 'BEGIN { print "/* DO NOT EDIT THIS FILE */\n"; } \
          s/\@{4}vstr_/vstr_$1/; \
          s/\@{4};/;/;' \
  include/vstr-extern.h.pre > include/vstr-extern.h
perl -pe 'BEGIN { print "/* DO NOT EDIT THIS FILE */\n"; } \
          s/\@{4}vstr_/vstr_nx_$1/; \
          s/\@{4};/VSTR__ATTR_H() ;/;' \
  include/vstr-extern.h.pre > include/vstr-internal-extern.h

# produce a local and external copy of vstr-inline.h ...

perl -pe 'BEGIN { print "/* DO NOT EDIT THIS FILE */\n"; } \
          s/\@{4}vstr_(extern_inline_)/vstr_$1/; \
          s/\@{4}vstr_/vstr_/;' \
  include/vstr-inline.h.pre > include/vstr-inline.h
perl -pe 'BEGIN { print "/* DO NOT EDIT THIS FILE */\n"; } \
          s/\@{4}vstr_(extern_inline_)/vstr_nx_$1/; \
          s/\@{4}vstr_/vstr_nx_/;' \
  include/vstr-inline.h.pre > include/vstr-internal-inline.h

# perl -pe 'BEGIN { print "/* DO NOT EDIT THIS FILE */\n"; } \
#           s/\@{4}vstr_(extern_inline_)/vstr_nx_$1/; \
#           s/\@{4}vstr_/vstr_/;' \
#   include/vstr-inline.h.pre > include/vstr-internal-c-inline.h


